package cn.iocoder.yudao.module.server.service.fileforconfig;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.server.controller.admin.fileforconfig.vo.*;
import cn.iocoder.yudao.module.server.dal.dataobject.fileforconfig.FileForConfigDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.server.dal.mysql.fileforconfig.FileForConfigMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.server.enums.ErrorCodeConstants.*;

/**
 * 文件配置 Service 实现类
 *
 * @author TRS
 */
@Service
@Validated
public class FileForConfigServiceImpl implements FileForConfigService {

    @Resource
    private FileForConfigMapper fileForConfigMapper;

    @Override
    public Long createFileForConfig(FileForConfigSaveReqVO createReqVO) {
        // 插入
        FileForConfigDO fileForConfig = BeanUtils.toBean(createReqVO, FileForConfigDO.class);
        fileForConfigMapper.insert(fileForConfig);
        // 返回
        return fileForConfig.getId();
    }

    @Override
    public void updateFileForConfig(FileForConfigSaveReqVO updateReqVO) {
        // 校验存在
        validateFileForConfigExists(updateReqVO.getId());
        // 更新
        FileForConfigDO updateObj = BeanUtils.toBean(updateReqVO, FileForConfigDO.class);
        fileForConfigMapper.updateById(updateObj);
    }

    @Override
    public void deleteFileForConfig(Long id) {
        // 校验存在
        validateFileForConfigExists(id);
        // 删除
        fileForConfigMapper.deleteById(id);
    }

    private void validateFileForConfigExists(Long id) {
        if (fileForConfigMapper.selectById(id) == null) {
            throw exception(FILE_FOR_CONFIG_NOT_EXISTS);
        }
    }

    @Override
    public FileForConfigDO getFileForConfig(Long id) {
        return fileForConfigMapper.selectById(id);
    }

    @Override
    public PageResult<FileForConfigDO> getFileForConfigPage(FileForConfigPageReqVO pageReqVO) {
        return fileForConfigMapper.selectPage(pageReqVO);
    }

}